﻿//Copyright © Pavel Torgashov, p_torgashov@ukr.net, GPL3, 2015

using System;
using System.Drawing;
using System.Windows.Forms;
using SkewCorrectionNS;

namespace Tester
{
    public partial class MainForm : Form
    {
        public MainForm()
        {
            InitializeComponent();
        }

        private void miOpen_Click(object sender, EventArgs e)
        {
            var ofd = new OpenFileDialog { Filter = "Image|*.png;*.jpeg;*.jpg;*.tif" };
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                ProcessFile(ofd.FileName);
            }
        }


        private void ProcessFile(string filePath)
        {
            var img = (Bitmap)Image.FromFile(filePath);
            pbLeft.Image = (Bitmap)img.Clone();

            //create strips
            var stripCount = 10;

            var compact = new Compact(img, stripCount);

            //find rotation angle
            var stripX1 = 2;//take 3-rd strip
            var stripX2 = 6;//take 7-th strip

            var angle = SkewCalculator.FindRotateAngle(compact, stripX1, stripX2);
            angle = (angle * 180 / Math.PI);//to degrees

            Text = "Angle: " + angle.ToString("0.00");

            //rotate
            var rotated = Rotator.Rotate(img, angle);
            pbRight.Image = rotated;
        }

        private void pbLeft_Paint(object sender, PaintEventArgs e)
        {
            using(var pen = new Pen(Color.FromArgb(20, Color.Black)))
            for (int i = 0; i < 1000; i += 30)
                e.Graphics.DrawLine(pen, 0, i, 1000, i);
        }
    }
}
